#! /usr/bin/perl

$this_dir = $0;
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");

require 'library.cgi';
require 'config.cgi';

&parse_form;

if($FORM{'action'} eq "") {

	# Print the frameset
	print "Content-Type: text/html\n\n";
	print qq!
	<HTML>
	<HEAD>
	<TITLE>Voting Center Administration $version</TITLE>
	</HEAD>
	<FRAMESET COLS="150,*" BORDER=0 FRAMEBORDER=0 FRAMESPACING=0>
	<FRAME NAME="menu" SRC="admin.cgi?action=menu" SCROLLING="NO">
	<FRAME NAME="main" SRC="admin.cgi?action=main" SCROLLING="YES">
	</FRAMESET>
	!;
}

elsif($FORM{'action'} eq "menu") {
	
	# Print the left control panel menu
	print "Content-Type: text/html\n\n";
	print qq!
	<HTML>
	<HEAD><TITLE>Menu</TITLE></HEAD>
	<BODY BGCOLOR="#66CCFF" TEXT="#000000" LINK="0000FF" ALINK="0000FF" VLINK="0000BB">
	<CENTER>
	<FONT FACE="Arial" SIZE=2>
	<H3>Voting Center</H3>
	<H4>Control Panel</H4>
	</CENTER>
	<A HREF="admin.cgi?action=main" TARGET="main">Admin Home</A><BR>
	<HR>
	<A HREF="admin.cgi?action=new" TARGET="main">Create Topic</A><BR>
	<HR>
	<A HREF="admin.cgi?action=settings" TARGET="main">Settings</A><BR>
	<HR>
	<A HREF="vcenter.cgi" TARGET="_new">Your Voting Center</A><BR>
	<HR>
	<A HREF="http://www.web-consult.com/scripts/vcenter/doc" TARGET="main">Documentation</A><BR>
	<HR>
	<A HREF="http://www.web-consult.com/cgi-bin/forum/Ultimate.cgi" TARGET="_new">Tech Support</A><BR>
	<HR>
	<A HREF="http://www.web-consult.com/scripts/buy-v.html" TARGET="_new">Purchase</A><BR>
	
	</BODY>
	!;
}

elsif($FORM{'action'} eq "main") {

	&check_pass;	
	# Print the main administration page
	&admin_header;
	print qq!
	Welcome to the Voting Center administration area.  Here you can create and maintain your
	polling topics.  If this is your first time using Voting Center, you should check out
	the <A HREF="admin.cgi?action=settings">settings</A>
	page to change the settings of Voting Center to the way you would like it.<P>
	
	The control panel to the left is where you will find links to pages where you can
	create new topics, edit the settings, and view documenation on Voting Center.<P>
	
	<H2>Current Topics</H2>
	<TABLE BGCOLOR="FFFFFF" CELLSPACING=2 CELLPADDING=2 BORDER=0>
	<TR BGCOLOR="#66CCFF"><TD><B>Topic Name</B></TD><TD><B># Votes</B></TD><TD><B>Expiration</B></TD><TD><B>Actions</B></TD></TR>
	!;
	
	opendir(BASE,"$base_dir") || &admin_error("Unable to read from the Voting Center directory");
	while($file = readdir(BASE)) {
		if($file =~ /^(.*)\.info$/) {
			$name = $1;
			push(@TOPICS,"$name");
			open(INFO,"$base_dir/$file") || &admin_error("Unable to read from Voting Center file: $file");
			@MYINFO =<INFO>;
			close(INFO);
			
			chomp($MYINFO[2]);
			if($MYINFO[2] =~ /never/i) {
				$exp_date = "Never";
			}
			else {
				($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($MYINFO[2]);
				$year += 1900;
			
				$exp_date = "$months[$mon] $mday, $year ($days[$wday])";
			}
			
			print qq!
			<TR BGCOLOR="#DDDDDD"><TD>$name</TD><TD>$MYINFO[0]</TD><TD>$exp_date</TD>
			<TD><A HREF="admin.cgi?action=delete&name=$name">Delete</A>
			| <A HREF="admin.cgi?action=edit&name=$name">Edit</A> |
			<A HREF="vcenter.cgi?action=show&topic=$name">View Results</A> |
			!;
			
			if(-e "$base_dir/$name.exp") {
				print qq!
				Expired</TD></TR>
				!;	
			}
			else {
				print qq!
				<A HREF="admin.cgi?action=expire&name=$name">Expire</A></TD></TR>
				!;
			}
		}
	}
	closedir(BASE);
	print qq!
	</TABLE><P><BR>
	
	<H3>SSI Topic</H3>
	In order to use the server side includes feature you must choose a topic that it will display.
	The server side includes feature can only display one topic at a time.  This feature is mainly
	used for those who want to insert the results into a web page instead of having a page
	dedicated to Voting Center by itself.<P>
	
	<FORM ACTION="admin.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="Set SSI">
	<SELECT NAME="ssi_topic">
	<OPTION VALUE="">- Select One -</OPTION>
	!;
	
	if(-e "$base_dir/ssi_topic.txt") {
		open(TOPIC,"$base_dir/ssi_topic.txt");
		chomp($ssi_topic = <TOPIC>);
		close(TOPIC);
		$SELECTED{$ssi_topic} = " SELECTED";
	}
	
	foreach $topic (@TOPICS) {
		print "<OPTION $SELECTED{$topic}>$topic</OPTION>\n";
	}
	
	print qq!
	</SELECT><P>
	<INPUT TYPE="SUBMIT" VALUE="Set Topic">
	</FORM>
	!;
	
	&admin_footer;
	
}

elsif($FORM{'action'} eq "new") {
	
	&check_pass;
	# Print the add topic page
	&admin_header;
	print qq!
	<H3>Adding a New Topic</H3>
	<FORM ACTION="admin.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="create">
	Fill out the form below in order to create a new topic.  You can use HTML in the
	answer choices so that you can use the &lt;img&gt; tag and other HTML tags.<P>
	
	Specify a reference name for your topic (Spaces will be converted to underscores '_'):<BR>
	<INPUT TYPE="TEXT" SIZE=20 NAME="name"><P>
	
	Enter the number of days before this topic will expire and be archived
	(Enter <I>never</I> if you do not want the topic to expire):<BR>
	<INPUT TYPE="TEXT" SIZE=10 NAME="expire"><P>
	
	Enter the question of your topic:<BR>
	<INPUT TYPE="TEXT" SIZE=40 NAME="question"><P>
	
	Now you can enter up to 20 answers to your question.  If you do not want to use
	all the answers that you are allowed, just leave the remaining ones blank.<P>
	
	<TABLE BORDER=0>
	<TR><TD>
	<INPUT TYPE="TEXT" NAME="answer1" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer2" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer3" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer4" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer5" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer6" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer7" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer8" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer9" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer10" SIZE=25><BR>
	</TD><TD>
	<INPUT TYPE="TEXT" NAME="answer11" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer12" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer13" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer14" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer15" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer16" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer17" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer18" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer19" SIZE=25><BR>
	<INPUT TYPE="TEXT" NAME="answer20" SIZE=25><BR>
	</TD></TR>
	</TABLE><P>
	
	<B>Redirect URL</B> (Optional)  If specified, Voting Center will automatically
	redirect your users to this URL after they vote.<BR>
	<INPUT TYPE="TEXT" SIZE=40 NAME="redirect"><P>
	
	<INPUT TYPE="SUBMIT" VALUE="Create Topic">
	</FORM>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "create") {
	
	&check_pass;
	# Create the new topic
	&admin_error("You did not fill out the required fields.  Click <A HREF=\"javascript:history.back()\">here</A>
				to go back and try again") unless $FORM{'question'} && $FORM{'expire'} && $FORM{'name'};
	
	if($FORM{'name'} =~ /\W/) {
		&admin_error("Please only use regular characters for the topic name. A-Z, a-z, 0-9. Click <A HREF=\"javascript:history.back()\">here</A> to go back and try again");
	}
	if($FORM{'redirect'}) {
		if($FORM{'redirect'} !~ /.*\:\/\/.*/) {
			&admin_error("You have entered an invalid URL.  Please remember to include the http:// in your URL");
		}
	}
	
	$FORM{'name'} =~ s/\s/\_/g;
	
	unless($FORM{'expire'} =~ /^\d*$/ || $FORM{'expire'} =~ /never/i) {
		&admin_error("You must enter the number of days before the topic expires or \"never\" in the expiration field");
	}
	
	if($FORM{'expire'} =~ /^\d*$/) {
		$exp = $FORM{'expire'} * 24 * 60 * 60;
		$exp += time;
	}
	else {
		$exp = "never";
	}
	
	open(INFO,">$base_dir/$FORM{'name'}.info") || &admin_error("Unable to create Voting Center file: $FORM{'name'}.info");
	open(DAT,">$base_dir/$FORM{'name'}.dat") || &admin_error("Unable to create Voting Center file: $FORM{'name'}.dat");
	print INFO "0\n";
	print INFO "$FORM{'question'}\n";
	print INFO "$exp\n";
	print INFO "$FORM{'redirect'}\n";
	
	$info_entry = "";
	for($i=1;$i<=20;$i++) {
		$field = "answer$i";
		if($FORM{$field} ne "") {
			$info_entry .= "$FORM{$field}&&";
			print DAT "0\n";
		}
	}
	chop($entry);
	chop($entry);
	print INFO "$info_entry";
	close(INFO);
	close(DAT);
	
	$ssi_dir = $script_directory;
	
	$ssi_dir =~ s/^(.*)\:\/\/[^\/]*\//\//;
	
	
	&admin_header;
	print qq!
	<H3>Topic Created</H3>
	Your topic, $FORM{'name'}, has been created successfully.<P>
	
	Your topic will now be listed on the Voting Center main page.  You can
	access the Voting Center main page at the following URL.<P>
	
	$script_directory/vcenter.cgi<P>
	
	You can also directly access your topic by linking to the following URL.<P>
	
	$script_directory/vcenter.cgi?topic=$FORM{'name'}&action=vpage<P>
	
	To access just the results of the topic use the following URL.<P>
	
	$script_directory/vcenter.cgi?topic=$FORM{'name'}&action=show<P>
	
	You can also use the server side includes feature for Voting Center if your
	server allows you to use them.  To use server side includes simply insert the
	following code in your HTML file where you would like your poll to appear.
	You must have server side includes enabled for this feature to work.<P>
	
	&lt;\!--#exec cgi="$ssi_dir/vcenter-ssi.cgi"--&gt;<P>
	
	If you use server side includes, you must remember to set a SSI Topic in the
	administration page in order for it to work correctly.<P>

	Click <A HREF="admin.cgi?action=main">here</A> to return to administration home.<P>
	!;
	&admin_footer;
	
}

elsif($FORM{'action'} eq "delete") {

	&check_pass;
	# Print the remove confirmation page.
	&admin_header;
	print qq!
	<H3>Are you sure?</H3>
	Are you sure you want to delete the topic, $FORM{'name'}?<P>
	<FORM ACTION="admin.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="Delete Confirmed">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="SUBMIT" VALUE="Yes, I am sure">
	</FORM><P>
	Click <A HREF="admin.cgi?action=main">here</A> to return to administration home.<P>
	!;
	&admin_footer;
	
}

elsif($FORM{'action'} eq "Delete Confirmed") {

	&check_pass;
	# Delete the specified topic
	
	if(! -e "$base_dir/$FORM{'name'}.info") {
		&admin_error("The topic, $FORM{'name'}, does not exist.");
	}
	
	unlink("$base_dir/$FORM{'name'}.info") || &admin_error("Unable to remove Voting Center file: $FORM{'name'}.info");;
	
	if(-e "$base_dir/$FORM{'name'}.dat") {
		unlink("$base_dir/$FORM{'name'}.dat") || &admin_error("Unable to remove Voting Center file: $FORM{'name'}.dat");
	}
	
	if(-e "$base_dir/$FORM{'name'}.exp") {
		unlink("$base_dir/$FORM{'name'}.exp") || &admin_error("Unable to remove Voting Center file: $FORM{'name'}.exp");
	}
	
	&admin_header;
	print qq!
	<H3>Topic Deleted</H3>
	The topic, $FORM{'name'}, has been deleted.<P>
	Click <A HREF="admin.cgi?action=main">here</A> to return to administration home.<P>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "settings") {
	
	&check_pass;
	# Output the settings page
	$SELECTED{$validate_type} = " SELECTED";
	
	if(-e "$base_dir/header.txt") {
		open(HEADER,"$base_dir/header.txt");
		@MHEADER=<HEADER>;
		close(HEADER);
		$header_file = join("",@MHEADER);
	}
	
	if(-e "$base_dir/footer.txt") {
		open(FOOTER,"$base_dir/footer.txt");
		@MFOOTER = <FOOTER>;
		close(FOOTER);
		$footer_file = join("",@MFOOTER);
	}
	
	&admin_header;
	print qq!
	<H2>Settings</H2>
	You may change any settings you would like below.  After you are done changing the settings
	click on the "Save Settings" button at the bottom in order to save your changes.<P>
	
	<FORM ACTION="admin.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="Edit Settings">
	
	<H3>System Settings</H3>
	
	<B>Base Directory:</B> The path to the directory where Voting Center will store its files.<BR>
	<INPUT TYPE="TEXT" NAME="base_dir" SIZE=40 VALUE="$base_dir"><P>
	
	<B>Script Directory:</B> The URL to the directory where the Voting Center scripts are located.<BR>
	<INPUT TYPE="TEXT" NAME="script_directory" SIZE=40 VALUE="$script_directory"><P>
	
	<B>Image URL:</B> The URL to the bar graphic file.  (This should be located outside of
	the cgi-bin directory)<BR>
	<INPUT TYPE="TEXT" NAME="image_url" SIZE=40 VALUE="$image_url"><P>
	<BR>
	<H3>Voting Center Settings</H3>
	
	<B>Validation Type:</B> The validation type is how you would like Voting Center to
	prevent double voting.<BR>
	<SELECT NAME="validate_type">
	<OPTION VALUE="0"$SELECTED{'0'}>None</OPTION>
	<OPTION VALUE="1"$SELECTED{'1'}>IP Address Logging</OPTION>
	<OPTION VALUE="2"$SELECTED{'2'}>Save Cookies</OPTION>
	<OPTION VALUE="3"$SELECTED{'3'}>Both Cookies and IP Logging (Recommended)</OPTION>
	</SELECT><P>
	
	<B>IP Log Time:</B> If you have IP logging enabled, how long do you want to keep
	each IP address.  The default value is recommended.  If you keep an IP address too
	long users who haven't voted before may start getting errors saying that they have
	already voted.<BR>
	<INPUT TYPE="TEXT" NAME="logtime" SIZE=10 VALUE="$logtime"><P>
	
	<B>Image Height:</B> The height of your bar graphic image in pixels.<BR>
	<INPUT TYPE="TEXT" NAME="img_height" SIZE=10 VALUE="$img_height"><P>
	
	<B>Bar Length Multiplier:</B>  This number determines how long your bar graphs will be.
	The higher the number the longer your bar graphs will be.<BR>
	<INPUT TYPE="TEXT" NAME="bar_length" SIZE=10 VALUE="$bar_length"><P>
	
	<B>SSI Bar Length Multiplier:</B> This number determines how long your bar graphs will be
	when using the server side includes feature.<BR>
	<INPUT TYPE="TEXT" NAME="ssi_bar_length" SIZE=10 VALUE="$ssi_bar_length"><P>
	
	<BR>
	<H3>HTML Settings</H3>
	
	<B>Header HTML:</B>  The header HTML code will be used to as the head
	of every HTML page that the vcenter.cgi outputs.<P>
	<TEXTAREA NAME="header" COLS=40 ROWS=7 WRAP="OFF">$header_file</TEXTAREA>
	<P>
	
	<B>Footer HTML:</B> The footer HTML code will be used as the foot of every
	HTML page that the vcenter.cgi outputs.<P>
	<TEXTAREA NAME="footer" COLS=40 ROWS=7 WRAP="OFF">$footer_file</TEXTAREA>
	<P>
	
	The following settings will be used when Voting Center generates tables.<P>
	
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>
	<TR><TD>
	<B>Table Width</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="table_width" VALUE="$table_width"></TD></TR>
	
	<TR><TD>
	<B>Table Border</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="table_border" VALUE="$table_border"></TD></TR>
	
	<TR><TD>
	<B>Cellspacing</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="table_cellspacing" VALUE="$table_cellspacing"></TD></TR>
	
	<TR><TD>
	<B>Cellpadding</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="table_cellpadding" VALUE="$table_cellpadding"></TD></TR>
	
	<TR><TD>
	<B>Table background color</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="table_color" VALUE="$table_color"></TD></TR>
	
	<TR><TD>
	<B>Row background color</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="row_color" VALUE="$row_color"></TD></TR>
	
	<TR><TD>
	<B>Caption row background color &nbsp; </B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="caption_color" VALUE="$caption_color"></TD></TR>
	
	<TR><TD>
	<B>Font color</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="font_color" VALUE="$font_color"></TD></TR>
	
	<TR><TD>
	<B>Font face</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="font_face" VALUE="$font_face"></TD></TR>
	
	<TR><TD>
	<B>font size</B></TD><TD>
	<INPUT TYPE="TEXT" SIZE=10 NAME="font_size" VALUE="$font_size"></TD></TR>
	</TABLE><P>
	<INPUT TYPE="HIDDEN" NAME="lockfile_max_try" VALUE="$lockfile_max_try">
	<INPUT TYPE="HIDDEN" NAME="version" VALUE="$version">
	<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$this_dir">
	<INPUT TYPE="SUBMIT" VALUE="Save Settings"><P>
	</FORM>
	!;
	&admin_footer;
	
}

elsif($FORM{'action'} eq "Edit Settings") {
	
	&check_pass;
	# Edit the configuration file
	
	$FORM{'this_dir'} =~ s/\\/\//g;
	$FORM{'base_dir'} =~ s/\\/\//g;
	
	if($FORM{'this_dir'} =~ /\/$/) {
		chop($FORM{'this_dir'});
	}
	if($FORM{'base_dir'} =~ /\/$/) {
		chop($FORM{'base_dir'});
	}
	open(CONFIG,">$FORM{'this_dir'}/config.cgi") || &admin_error("Unable to open the Voting Center configuration file.  Please check that you have set the permissions to 777 on the config.cgi.");
	foreach $key (keys %FORM) {
		if($key eq "header" || $key eq "footer" || $key eq "action") {
			next;
		}
		print CONFIG "\$$key = \"$FORM{$key}\";\n";
	}
	close(CONFIG);
	
	if($FORM{'header'}) {
		open(HEADER,">$base_dir/header.txt") || &admin_error("Unable to create header file");
		print HEADER "$FORM{'header'}";
		close(HEADER);
	}
	
	if($FORM{'footer'}) {
		open(FOOTER,">$base_dir/footer.txt") || &admin_error("Unable to create footer file");
		print FOOTER "$FORM{'footer'}";
		close(FOOTER);
	}
	&admin_header;
	print qq!
	<H3>Your settings have been saved</H3>
	Click <A HREF="admin.cgi?action=main">here</A> to return to administration home.<P>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "edit") {
	
	&check_pass;
	
	open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("Unable to open Voting Center file: $FORM{'name'}.info");
	@MYINFO =<INFO>;
	close(INFO);
	chomp($MYINFO[0]);
	chomp($MYINFO[1]);
	chomp($MYINFO[2]);
	chomp($MYINFO[3]);
	chomp($MYINFO[4]);
	@answers = split(/\&\&/,$MYINFO[4]);
	$mytime = time;
	$days = int(($MYINFO[2] - $mytime) / 60 / 60 / 24);
	
	&admin_header;
	print qq!
	<H3>Topic name: $FORM{'name'}</H3>
	Edit the information below and then press submit to save it<P>
	<FORM ACTION="admin.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="save edit">
	<INPUT TYPE="HIDDEN" NAME="count" VALUE="$MYINFO[0]">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	Question<BR>
	<INPUT TYPE="TEXT" SIZE=40 NAME="question" VALUE="$MYINFO[1]"><P>
	Redirect URL<BR>
	<INPUT TYPE="TEXT" SIZE=40 NAME="redirect" VALUE="$MYINFO[3]"><P>
	This topic will expire in
	<INPUT TYPE="TEXT" NAME="expire" VALUE="$days" SIZE=5> days<P>
	!;
	$i = 1;
	
	foreach $answer (@answers) {
		print qq!Answer $i:
		<INPUT SIZE="30" NAME="answer$i" VALUE="$answer"><BR>
		!;
		$i++;
	}
	
	print qq!
	<INPUT TYPE="HIDDEN" NAME="num" VALUE="$i"><P>
	<INPUT TYPE="SUBMIT" VALUE="Save Changes">
	</FORM>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "save edit") {
	
	&check_pass;
	
	&file_lock("$FORM{'name'}");
	
	$entry = "";
	for($i=1;$i<$FORM{'num'};$i++) {
		$field = "answer$i";
		$entry .= "$FORM{$field}&&";
	}
	chop($entry);
	chop($entry);
	
	$exp = $FORM{'expire'} * 24 * 60 * 60;
	$exp += time;

	open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("Unable to open Voting Center file: $FORM{'name'}.info");
	@MYINFO = <INFO>;
	close(INFO);
	
	chomp($MYINFO[0]);
	
	open(INFO,">$base_dir/$FORM{'name'}.info") || &admin_error("Unable to write to Voting Center file: $FORM{'name'}.info");
	print INFO "$MYINFO[0]\n";
	print INFO "$FORM{'question'}\n";
	print INFO "$exp\n";
	print INFO "$FORM{'redirect'}\n";
	print INFO "$entry";
	close(INFO);
	
	&file_unlock("$FORM{'name'}");
	
	&admin_header;
	print qq!
	<H3>Your Changes have been saved</H3>
	Click <A HREF="admin.cgi?action=main">here</A> to return to administration home.<P>
	!;
	&admin_footer;
	
}

elsif($FORM{'action'} eq "Set SSI") {
	&check_pass;
	
	open(TOPIC,">$base_dir/ssi_topic.txt") || &admin_error("Unable to write to Voting Center file: ssi_topic.txt");
	print TOPIC "$FORM{'ssi_topic'}";
	close(TOPIC);
	
	&admin_header;
	print qq!
	<H3>Topic Set Successfully</H3>
	click <A HREF="admin.cgi?action=main">here</A> to return to administration home.<P>
	!;
	&admin_footer;
	
}
elsif($FORM{'action'} eq "expire") {
	&check_pass;
	&admin_header;
	print qq!
	<H3>Are you sure?</H3>
	Are you sure you would like to expire this topic and archive it in the pervious topics?<P>
	
	<FORM ACTION="admin.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="Expire Confirmed">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="SUBMIT" VALUE="Yes, I am sure">
	</FORM><P>
	click <A HREF="admin.cgi?action=main">here</A> to return to administration home.<P>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "Expire Confirmed") {

	open(EXP,">$base_dir/$FORM{'name'}.exp") || &admin_error("Unable to create Voting Center file: $FORM{'name'}.exp");
	print EXP "";
	close(EXP);
	
	&admin_header;
	print qq!
	<H3>Topic Expired</H3>
	The topic is now expired and is now archived in the pervious topics section.<P>
	click <A HREF="admin.cgi?action=main">here</A> to return to administration home.<P>
	!;
	&admin_footer;
}
else {
	&admin_error("Invalid Data: Voting Center does not understand the parameters you specified");
}