@months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
@days = qw(Mon Tue Wed Thu Fri Sat Sun);

@Encode_Chars = ('\%', '\+', '\;', '\,', '\=', '\&', '\:', '\s', '\"');

%Encode_Chars = ('\%',   '%25',
                 '\+',   '%2B',
                 '\;',   '%3B',
                 '\,',   '%2C',
                 '\=',   '%3D',
                 '\&',   '%26',
                 '\:',   '%3A',
                 '\"',   '%22',
                 '\s',   '+');
                 
sub parse_form {
	
	if($ENV{'REQUEST_METHOD'} eq "POST") {
   		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}
	
	if($ENV{'REQUEST_METHOD'} eq "GET") {
		$buffer = $ENV{'QUERY_STRING'};
	}
   
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $name =~ tr/+/ /;
      $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/\&\&/\&/g;
      #$value =~ s/<!--(.|\n)*-->//g;

      $FORM{$name} = $value;
   }
}

sub admin_header {
	my $flag = shift;
	
	print "Content-Type: text/html\n\n";
	print qq!
	<HTML>
	<HEAD>
	<TITLE>Voting Center $version Administration</TITLE>
	!;
	
	if($flag) {
		print qq!<script type="text/javascript" language="javascript" src="admin.cgi?action=spellchecker"></script>\n!;
	}
	
	print qq!
	</HEAD>
	<BODY BGCOLOR="FFFFFF" TEXT="000000" ALINK="0000FF" VLINK="0000FF" ALINK="0000BB">
	<CENTER>
	<TABLE WIDTH="600" BORDER=0>
	<TR><TD>
	<FONT FACE="Arial" SIZE=2>
	<CENTER><H1>Voting Center Administration</H1></CENTER>
	<HR SIZE=1><P>
	!;
}

sub admin_footer {
	print qq!
	<P><HR SIZE=1><P>
	</TD></TR>
	</TABLE>
	</CENTER>
	</BODY>
	</HTML>
	!;
}

sub admin_error {
	my $msg = shift;
	&admin_header;
	print qq!
	<H3>Voting Center Error</H3>
	$msg
	!;
	&admin_footer;
	exit;
}

sub header {
	
	print "Content-Type: text/html\n\n";
	
	if(-e "$base_dir/header.txt") {
		open(HEADER,"$base_dir/header.txt");
		@MHEADER=<HEADER>;
		close(HEADER);
		print "@MHEADER";
	}
	else {
		print qq!
		<HTML>
		<HEAD>
		<TITLE>Voting Center $version</TITLE>
		</HEAD>
		<BODY BGCOLOR="FFFFFF" TEXT="000000" LINK="0000FF" VLINK="0000BB" ALINK="0000BB">
		<CENTER>
		<TABLE BGCOLOR="#FFFFFF" WIDTH=600 BORDER=0>
		<TR><TD>
		<CENTER>
		<FONT FACE="Arial" SIZE=6><B>Voting Center $version</B></FONT><BR>
		</CENTER>
		</TD></TR>
		<TR><TD>
		<FONT FACE="Arial">
		<BR>
		!;
	}
}

sub footer {
	
	if(-e "$base_dir/footer.txt") {
		open(FOOTER,"$base_dir/footer.txt");
		@MFOOTER=<FOOTER>;
		close(FOOTER);
		print "@MFOOTER";
	}
	else {
		print qq!
		</FONT>
		</TD></TR>
		</TABLE></CENTER>
		</BODY>
		</HTML>
		!;
	}
}

sub error {
	my $error = shift;	
	&header;
	print "<H3>Post Office Error</H3>\n";
	print "<B>$error</B><P>\n";
	print "<BR><BR><CENTER><FONT FACE=\"Arial\" SIZE=2>Powered by <A HREF=\"http://www.web-consult.com/scripts/\">Voting Center</A> $version, CGI Paradise</FONT></CENTER>\n";
	&footer;
	exit;
}

sub check_pass {
	
	$nowtime = time;
	
	# Lets check for users that have timed out
	opendir(BASE,"$base_dir") || &admin_error("Unable to read data from the Post Office directory");
	while($file = readdir(BASE)) {
		if($file =~ /(.*)\.session$/) {
			open(FILE,"$base_dir/$file") || &admin_error("Can't open the session file");
			chomp($mytime =<FILE>);
			close(FILE);
			
			if($nowtime - $mytime > 7200) {
				# If the session is too old, time them out
				unlink("$base_dir/$file");
			}
		}
	}
	closedir(BASE);
	
	my $cookie = &getcookie("VCID");
	
	if(! $cookie) {
		# If the does not exist, lets log them in
		
		open(FILE,"$base_dir/password.txt") || &admin_error("Can't open the password file!");
		my $line =<FILE>;
		chomp($line);
		close(FILE);
	
		my ($username,$password) = split(/\:/,$line);
		my $epassword = crypt($FORM{'password'},"VC");
		
		if($FORM{'username'} eq "$username" && $password eq "$epassword") {
			my $nowtime = time;
			my $session = $nowtime;
			open(FILE,">$base_dir/$session.session") || &admin_error("Can't create the session file");
			print FILE "$nowtime";
			close(FILE);
			&setcookie("VCID","$session");
		}
		else {
			# Invalid username or password
			&admin_header;
			
			if($FORM{'username'} && $FORM{'password'}) {
				print qq!
				<H3>Invalid username or password</H3>
				!;
			}
			else {
				print qq!
				<H3>Login</H3>
				!;	
			}
			
			print qq!
			<B>Please login by entering your username and password in order to enter the administration area.</B><P>
			<FORM ACTION="admin.cgi" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="main">
			<INPUT TYPE="TEXT" SIZE=15 NAME="username"> Username<BR>
			<INPUT TYPE="PASSWORD" SIZE=15 NAME="password"> Password<BR><BR>
			<INPUT TYPE="SUBMIT" VALUE="Continue">
			</FORM>
			!;
			&admin_footer;
			exit;
		}
	}
	else {
		# If we found a cookie, lets check the session

		if(-e "$base_dir/$cookie.session") {
			
			# If everything is ok, update the session time

			open(FILE,">$base_dir/$cookie.session") || &admin_error("Can't create the session file");
			print FILE "$nowtime";
			close(FILE);

		}
		else {
			# If the session file isn't found, log them in

			&setcookie("VCID","0");
			&admin_header;
			print qq!
			<H3>Your session has timed out</H3>
			<B>Please login by entering your username and password in order to enter the administration area.</B><P>
			<FORM ACTION="admin.cgi" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="main">
			<INPUT TYPE="TEXT" SIZE=15 NAME="username"> Username<BR>
			<INPUT TYPE="PASSWORD" SIZE=15 NAME="password"> Password<BR><BR>
			<INPUT TYPE="SUBMIT" VALUE="Continue">
			</FORM>
			!;
			&admin_footer;
			exit;
		}	
	}
}
sub getcookie {
	
	my $cookie_name = shift;
	$r = 0;
	
	@cookies = split(/\; /, $ENV{'HTTP_COOKIE'});
	
	foreach $cookie (@cookies) {
			
		($name, $value) = split(/=/, $cookie);
			
		#foreach $char (@Cookie_Decode_Chars) {
		#	$name =~ s/$char/$Cookie_Decode_Chars{$char}/g;
		#	$value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
		#}
		if($name eq "$cookie_name") {
			$r = $value;
			last;
		}
	}
	
	return $r;
}

sub setcookie {
	
	my $cname = shift;
	my $session = shift;
	
	#foreach $char (@Cookie_Encode_Chars) {
	#	$session =~ s/$char/$Cookie_Encode_Chars{$char}/g;
	#}
	
	print "Set-Cookie: $cname=" . $session . "\n";
}

sub file_lock {
	
    my $name = shift;
    my $lock_file = "$base_dir/$name\.lock";

    while(-e $lock_file) {
        if($i < $lockfile_max_try) {
        	sleep(1);
        	$i++;
        }
        else {
        	unlink("$lock_file");
        }
    }
    
    open(LOCK, ">$lock_file");
    print LOCK "Voting Center Lock File\n";
    close(LOCK);
}

sub file_unlock {
    my $name = shift;
    my $lock_file = "$base_dir/$name\.lock";
    unlink($lock_file);
}

sub validate {
	
	# Check if the user has voted before
	my $topic = shift;
	my $rvalue = 0;
	
	if($validate_type == 2 || $validate_type == 3) {
		@cookies = split(/\; /, $ENV{'HTTP_COOKIE'});
		foreach $cookie (@cookies) {
			($name, $value) = split(/=/, $cookie);
			if($name eq "$topic") {
				return $value;
			}
		}
	}
	
	if($validate_type == 1 || $validate_type == 3) {
		if(-e "$base_dir/$topic.log") {
			$ip = $ENV{'REMOTE_ADDR'};
			&file_lock("$survey.log");
			open(LOG,"$base_dir/$topic.log") || &error("Unable to open Survey Office file: $surveyoffice_base_dir/$topic.log");
			@IPLOG =<LOG>;
			close(LOG);
			
			$mytime = time;
			open(LOG,">$base_dir/$topic.log") || &error("Unable to write to Survey Office file: $surveyoffice_base_dir/$topic.log");
			foreach $line (@IPLOG) {
				($myip,$logtime) = split(/\&\&/,$line);
				if($myip =~ /$ip/) {
					$rvalue = 1;
				}
				if($mytime - $logtime < 24 * 60 * 60) {
					print LOG "$line";
				}
			}
			close(LOG);
			&file_unlock("$survey.log");
		}
	}
	
	return $rvalue;
}

sub loguser {
	my $topic = shift;
	# Log the user and set the cookie
	if($validate_type == 1 || $validate_type == 3) {
		my $mytime = time;
		
		&file_lock("$topic.log");
		if(! -e "$base_dir/$topic.log") {
			open(LOG,">$base_dir/$topic.log") || &error("Unable to create Voting Center file: $topic.log");
			print LOG "";
			close(LOG);
		}
		open(LOG,">>$base_dir/$topic.log") || &error("Unable to write to Voting Center file: $topic.log");
		print LOG "$ENV{'REMOTE_ADDR'}&&$mytime\n";
		close(LOG);
		&file_unlock("$topic.log");
	}
	
	if($validate_type == 2 || $validate_type == 3) {
		$cookie_name = "$topic";
		print "Set-Cookie: " . $cookie_name . "=1;expires=Fri, 30-Dec-2099 00:00:00 GMT\n";
	}
	
}

sub check_exp {

	opendir(BASE,"$base_dir") || &error("Unable to open the Voting Center directory");
	while($file = readdir(BASE)) {
		if($file =~ /^(.*)\.info$/) {
			$name = $1;
			open(INFO,"$base_dir/$file") || &error("Unable to open Voting Center file: $file");
			@MYINFO =<INFO>;
			close(INFO);
			
			$mytime = time;
			
			if($MYINFO[2] <= $mytime && $MYINFO[2] !~ /never/i) {
				open(EXP,">$base_dir/$name.exp") || &error("Unable to create Voting Center file: $name.exp");
				print EXP "";
				close(EXP);
			}
			
		}
	}
	closedir(BASE);
}

1;