#! /usr/bin/perl

$this_dir = $0;
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");

require 'library.cgi';
require 'config.cgi';

&check_exp;

if(-e "$base_dir/ssi_topic.txt") {
	open(TOPIC,"$base_dir/ssi_topic.txt");
	chomp($ssi_topic = <TOPIC>);
	close(TOPIC);
}
else {
	print "Content-Type: text/html\n\n";
	print "<B>There was no topic chosen to be displayed.</B>\n";
	exit;	
}

$FORM{'topic'} = $ssi_topic;
$voted = &validate("$ssi_topic");

if(-e "$base_dir/$ssi_topic.exp") {
	$expired = 1;
}
else {
	$expired = 0;
}

if($FORM{'QUERY_STRING'} =~ /results/i || $voted || $expired) {
	# Show Results
	open(INFO,"$base_dir/$FORM{'topic'}.info") || &error("Unable to open Voting Center file: $FORM{'topic'}.info");
	@MYINFO =<INFO>;
	close(INFO);
	
	chomp($MYINFO[0]);
	chomp($MYINFO[4]);
	
	@answers = split(/\&\&/,$MYINFO[4]);
	
	open(DAT,"$base_dir/$FORM{'topic'}.dat") || &error("Unable to open Voting Center file: $FORM{'topic'}.dat");
	@MYDATA =<DAT>;
	close(DAT);
	
	# Output results page for specified topic
	print "Content-Type: text/html\n\n";
	print qq!
	<TABLE BORDER=0 CELLSPACING="2" CELLPADDING="2">
	<TR><TD COLSPAN=2>
	<B><FONT FACE="$font_face" SIZE=$font_size><B>$MYINFO[1]</B> ($MYINFO[0] votes)</TD></TR>
	!;
	$i = 0;
	foreach $answer (@answers) {
		
		chomp($MYDATA[$i]);
		
		if($MYINFO[0] > 0) {
			$percentage = int($MYDATA[$i] / $MYINFO[0] * 100);
			$bar = $percentage * $ssi_bar_length;
		}
		else {
			$percentage = 0;
			$bar = 5;
		}
		
		print qq!
		<TR><TD>
		$answer<BR>
		</TD><TD>
		<IMG SRC="$image_url" HEIGHT="$img_height" WIDTH="$bar" BORDER=0> $MYDATA[$i] ($percentage\%)<BR>
		</TD></TR>
		!;
		$i++;
	}
	print qq!
	</TABLE>
	!;
}
else {
	# Show Voting Form
	open(INFO,"$base_dir/$FORM{'topic'}.info") || &error("Unable to open Voting Center file: $FORM{'topic'}.info");
	@MYINFO =<INFO>;
	close(INFO);
	
	chomp($MYINFO[4]);
	@answers = split(/\&\&/,$MYINFO[4]);
	
	print "Content-Type: text/html\n\n";
	
	print qq!
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>
	<FORM ACTION="$script_directory/vcenter.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="vote">
	<INPUT TYPE="HIDDEN" NAME="type" VALUE="ssi">
	<TR><TD COLSPAN=2>
	<B><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size><B>$MYINFO[1]</B></TD></TR>
	!;
	
	$i = 0;
	foreach $answer (@answers) {
		print qq!
		<TR><TD><INPUT TYPE="RADIO" NAME="vote" VALUE="$i"></TD>
		<TD WIDTH="95\%"><FONT FACE="$font_face" SIZE=$font_size>$answer</FONT></TD></TR>
		!;
		$i++;
	}
	print qq!
	<TR><TD COLSPAN=2>
	<CENTER>
	<INPUT TYPE="HIDDEN" NAME="topic" VALUE="$FORM{'topic'}">
	<INPUT TYPE="SUBMIT" VALUE="Vote"><BR>
	</CENTER>
	</TABLE></FORM><P>
	!;
}