#! /usr/bin/perl

$this_dir = $0;
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");

require 'library.cgi';
require 'config.cgi';

&parse_form;
&check_exp;

if($FORM{'action'} eq "") {
	
	# Output Voting Center main display page.
	
	opendir(BASE,"$base_dir") || &error("Unable to open the Voting Center directory");
	&header;
	print qq!

	<TABLE BORDER=$table_border CELLSPACING="$table_cellspacing" CELLPADDING="$table_cellpadding" BGCOLOR="$table_color" width="$table_width">
	<TR BGCOLOR="$caption_color"><TD COLSPAN=3>
	<B><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size><B>Current Topics</B></TD>
	</TR>
	!;
	
	$exp_topics = 0;
	while($file = readdir(BASE)) {
		if($file =~ /^(.*)\.info$/) {
			$name = $1;
			
			if(-e "$base_dir/$name.exp") {
				$exp_topics = 1;
				next;
			}
			
			open(INFO,"$base_dir/$file") || &error("Unable to open Voting Center file: $file");
			@MYINFO =<INFO>;
			close(INFO);
			
			if($MYINFO[2] =~ /never/i) {
				$exp_date = "Never";
			}
			else {
				($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($MYINFO[2]);
				$year += 1900;
			
				$exp_date = "$months[$mon] $mday, $year ($days[$wday])";
			}
			
			print qq!
			<TR BGCOLOR="$row_color"><TD><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size>$MYINFO[1]</FONT></TD>
			<TD>
			<FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size>
			<A HREF="vcenter.cgi?action=vpage&topic=$name">Vote</A> |
			<A HREF="vcenter.cgi?action=show&topic=$name">Results</A></FONT></TD>
			<TD><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size>Expires: $exp_date</FONT></TD></TR>
			!;
			
		}
	}
	print "</TABLE><P><BR>\n";
	closedir(BASE);
	
	if($exp_topics) {
		opendir(BASE,"$base_dir") || &error("Unable to open the Voting Center directory");
		print qq!
		<TABLE BORDER=$table_border CELLSPACING="$table_cellspacing" CELLPADDING="$table_cellpadding" BGCOLOR="$table_color" width="$table_width">
		<TR BGCOLOR="$caption_color"><TD COLSPAN=2>
		<B><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size><B>Previous Topics</B></TD></TR>
		!;

		while($file = readdir(BASE)) {
			if($file =~ /^(.*)\.info$/) {
				$name = $1;
			
				if(! -e "$base_dir/$name.exp") {
					next;
				}
			
				open(INFO,"$base_dir/$file") || &error("Unable to open Voting Center file: $file");
				@MYINFO =<INFO>;
				close(INFO);
			
				($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($MYINFO[2]);
				$year += 1900;
			
				$exp_date = "$months[$mon] $mday, $year ($days[$wday])";
			
				print qq!
				<TR BGCOLOR="$row_color"><TD><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size>$MYINFO[1]</FONT></TD>
				<TD>
				<FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size>
				<A HREF="vcenter.cgi?action=show&topic=$name">Results</A></FONT></TD>
				</TR>
				!;
			
			}
		}
		print "</TABLE>\n";
		closedir(BASE);
	}	
	&footer;
	
}

elsif($FORM{'action'} eq "show") {
	
	if(! -e "$base_dir/$FORM{'topic'}.info") {
		&error("The topic, $FORM{'topic'}, does not exist.");
	}
	
	open(INFO,"$base_dir/$FORM{'topic'}.info") || &error("Unable to open Voting Center file: $FORM{'topic'}.info");
	@MYINFO =<INFO>;
	close(INFO);
	
	chomp($MYINFO[0]);
	chomp($MYINFO[4]);
	
	@answers = split(/\&\&/,$MYINFO[4]);
	
	open(DAT,"$base_dir/$FORM{'topic'}.dat") || &error("Unable to open Voting Center file: $FORM{'topic'}.dat");
	@MYDATA =<DAT>;
	close(DAT);
	
	# Output results page for specified topic
	&header;
	print qq!
	<H3>Results</H3>
	<TABLE BORDER=$table_border CELLSPACING="$table_cellspacing" CELLPADDING="$table_cellpadding" BGCOLOR="$table_color" WIDTH="$table_width">
	<TR BGCOLOR="$caption_color"><TD COLSPAN=2>
	<B><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size><B>$MYINFO[1]</B> ($MYINFO[0] votes)</TD></TR>
	!;
	$i = 0;
	foreach $answer (@answers) {
		
		chomp($MYDATA[$i]);
		
		if($MYINFO[0] > 0) {
			$percentage = int($MYDATA[$i] / $MYINFO[0] * 100);
			$bar = $percentage * $bar_length;
		}
		else {
			$percentage = 0;
			$bar = 5;
		}
		
		print qq!
		<TR BGCOLOR="$row_color"><TD>
		$answer<BR>
		</TD><TD>
		<IMG SRC="$image_url" HEIGHT="$img_height" WIDTH="$bar" BORDER=0> $MYDATA[$i] ($percentage\%)<BR>
		</TD></TR>
		!;
		$i++;
	}
	print qq!
	</TABLE>
	!;
	&footer;
	
}

elsif($FORM{'action'} eq "vpage") {
	
	# Output Voting Page for the specified topic
	open(INFO,"$base_dir/$FORM{'topic'}.info") || &error("Unable to open Voting Center file: $FORM{'topic'}.info");
	@MYINFO =<INFO>;
	close(INFO);
	
	chomp($MYINFO[4]);
	@answers = split(/\&\&/,$MYINFO[4]);
	&header;
	print qq!
	<TABLE BORDER=$table_border CELLSPACING="$table_cellspacing" CELLPADDING="$table_cellpadding" BGCOLOR="$table_color" WIDTH="$table_width">
	<FORM ACTION="vcenter.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="vote">
	<TR BGCOLOR="$caption_color"><TD COLSPAN=2>
	<B><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size><B>$MYINFO[1]</B></TD></TR>
	!;
	
	$i = 0;
	foreach $answer (@answers) {
		print qq!
		<TR BGCOLOR="$row_color"><TD><INPUT TYPE="RADIO" NAME="vote" VALUE="$i"></TD>
		<TD WIDTH="95\%"><FONT FACE="$font_face" COLOR="$font_color" SIZE=$font_size>$answer</FONT></TD></TR>
		!;
		$i++;
	}
	print qq!
	<TR><TD COLSPAN=2>
	<CENTER>
	<INPUT TYPE="HIDDEN" NAME="topic" VALUE="$FORM{'topic'}">
	<INPUT TYPE="SUBMIT" VALUE="Submit Vote"><BR>
	</CENTER>
	</TABLE></FORM><P>
	!;
	&footer;
}

elsif($FORM{'action'} eq "vote") {
	
	# Log the vote for the specified topic
	if(&validate("$FORM{'topic'}")) {
		&error("Our records show that you have already voted for this topic.  Please only vote once per topic.");
	}
	if(! -e "$base_dir/$FORM{'topic'}.info") {
		&error("The topic you are trying to participate in, $FORM{'topic'}, was not found.");
	}
	if(-e "$base_dir/$FORM{'topic'}.exp") {
		&error("The topic you are trying to vote in has already expired and is no
		longer accepting votes.  However, you can see the results of the poll <A HREF=\"vcenter.cgi?action=show&topic=$FORM{'topic'}\">here</A>.");
	}
	
	&file_lock("$FORM{'topic'}");
	open(INFO,"$base_dir/$FORM{'topic'}.info") || &error("Unable to open Voting Center file: $FORM{'topic'}.info");
	@MYINFO =<INFO>;
	close(INFO);
	
	open(DAT,"$base_dir/$FORM{'topic'}.dat") || &error("Unable to open Voting Center file: $FORM{'topic'}.dat");
	@MYDATA = <DAT>;
	close(DAT);
	
	$vote = $FORM{'vote'};
	
	chomp($MYDATA[$vote]);
	$MYDATA[$vote] += 1;
	$MYDATA[$vote] .= "\n";
	
	open(DAT,">$base_dir/$FORM{'topic'}.dat") || &error("Unable to write to Voting Center file: $FORM{'topic'}.dat");
	print DAT @MYDATA;
	close(DAT);
	
	chomp($MYINFO[0]);
	$MYINFO[0] += 1;
	$MYINFO[0] .= "\n";
	
	open(INFO,">$base_dir/$FORM{'topic'}.info") || &error("Unable to write to Voting Center file: $FORM{'topic'}.info");
	print INFO @MYINFO;
	close(INFO);
	
	&file_unlock("$FORM{'topic'}");
	
	&loguser("$FORM{'topic'}");
	
	if($FORM{'type'} eq "ssi") {
		print "Content-Type: text/html\n";
		print "Location: $ENV{'HTTP_REFERER'}?results\n\n";
		exit;
	}
	
	chomp($MYINFO[3]);
	if($MYINFO[3] =~ /.*\:\/\/.*\..*/) {
		print "Content-Type: text/html\n";
		print "Location: $MYINFO[3]\n\n";
		exit;
	}
	
	&header;
	print qq!
	<H3>Your vote has been casted</H3>
	Thank you for participating in our poll.  The results have already been updated and you
	can view them <A HREF="vcenter.cgi?topic=$FORM{'topic'}&action=show">here</A>.<P>
	!;
	&footer;
}

else {
	&error("Invalid Data: Voting Center does not understand the parameters you specified");
}